/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Florian Zinggeler
 *   Co-authors:
 *      ...
 *
 */

/*TODO: orientation/direction of the ship must be defined
        implement shoot function ->or switch it on?
        switch off boosting particles in the back of the ship

/**
    @file Asteroids2DShip.cc
    @brief Implementation of the Asteroids2DShip class.
*/

#include "Asteroids2DShip.h"
#include "core/CoreIncludes.h"

namespace orxonox
{
    RegisterClass(Asteroids2DShip);

    Asteroids2DShip::Asteroids2DShip(Context* context) : SpaceShip(context)
    {
        RegisterObject(Asteroids2DShip);

        speed = 830;
        isFireing = false;
        damping = 10;
        this->width = 1043;
        this->height = 646;

        timer.setTimer(3.5f, true, createExecutor(createFunctor(&Asteroids2DShip::showposition, this)));
    }

    //Use this function to display your position on the field -> to determine field width and height
    void Asteroids2DShip::showposition()
    {
        Vector3 pos = this->getPosition();
        orxout() << "x = "<< pos.x << " y = " << pos.y << " z = "<< pos.z << endl; 
    }

    void Asteroids2DShip::tick(float dt)
    {
        SUPER(Asteroids2DShip, tick, dt);
        Vector3 pos = this->getPosition();

        //haelt ship innerhalb des Kamerafensters, kommt oben bzw seitlich wieder raus. Man spawnt in (0,0)
        if(pos.x > width/2)   pos.x = -width/2;
        if(pos.x < -width/2)  pos.x = width/2;
        if(pos.z > height/2)  pos.z = -height/2;
        if(pos.z < -height/2) pos.z = height/2;

        //2D movement, position should always = 0 on y-axis
        if(pos.y!=0) pos.y = 0;
        this->setPosition(pos);

        //update level

        //shoot?
    }

    void Asteroids2DShip::updateLevel()
    {
        if (getGame())
            getGame()->levelUp();
    }

/*    void Asteroids2DShip::moveFrontBack(const Vector2& value)
    {
        //lastTimeFront = 0;
        //desiredVelocity.y = value.y * speed * 42;
        orxout() << "FrontBack" << endl;
        SUPER(Asteroids2DShip, moveFrontBack, value);
    }

    void Asteroids2DShip::moveRightLeft(const Vector2& value)
    {
        //lastTimeLeft = 0;
        //desiredVelocity.x = value.x * speed;
        orxout() << "RightLeft" << endl;
        SUPER(Asteroids2DShip, moveFrontBack, value);       
    }
 */
    void Asteroids2DShip::boost(bool bBoost)
    {
        //getGame()->bEndGame = bBoost;
    }

    inline bool Asteroids2DShip::collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint)
    {

        removeHealth(100);
        this->death();
        return false;
    }

    Asteroids2D* Asteroids2DShip::getGame()
    {
        if (game == nullptr)
        {
            for (Asteroids2D* race : ObjectList<Asteroids2D>())
            {
                game = race;
            }
        }
        return game;
    }

    void Asteroids2DShip::death()
    {
        getGame()->costLife();
        SpaceShip::death();
    }
}
